/**
 * Copyright (c) 2011-2012 EBM WebSourcing, 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package com.ebmwebsourcing.jbi.adaptor.impl;

import javax.jbi.messaging.MessageExchange;
import javax.jbi.messaging.MessageExchange.Role;

/**
 * @author Marc Jambert - EBM WebSourcing
 */
public class WrappedResponseToConsumerMessage extends AbstractWrappedToComponentMessage {

    public WrappedResponseToConsumerMessage(MessageExchange messageExchange) {
        super(messageExchange);
        setRole(Role.CONSUMER);
    }

    @Override
    public String getPayload() {
        if(messageExchange.getFault() == null) {            
            return getPayload("out");
        } else {
            return getPayload("fault");
        }
    }
}
