/**
 * Copyright (c) 2011-2012 EBM WebSourcing, 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package com.ebmwebsourcing.jbi.adaptor.impl.transport;

import javax.jbi.messaging.MessageExchange;

import org.ow2.petals.component.api.Component;

import com.ebmwebsourcing.jbi.adaptor.impl.AbstractWrappedMessage;
import com.ebmwebsourcing.jbi.adaptor.impl.WrappedRequestToProviderMessage;
import com.ebmwebsourcing.jbi.adaptor.impl.WrappedResponseToConsumerMessage;

/**
 * @author Adrien Ruffie - EBM WebSourcing
 */
public class RequestResponseTransporter {

    private final Component sender;

    private final Component recipient;

    public RequestResponseTransporter(Component sender, Component recipient) {
        super();
        this.sender = sender;
        this.recipient = recipient;
    }

    public void transport() {
        AbstractWrappedMessage request = (AbstractWrappedMessage) sender.pollRequestFromConsumer();
        MessageExchange messageExchange = request.getMessageExchange();

        WrappedRequestToProviderMessage wrappedRequestMessage = new WrappedRequestToProviderMessage(messageExchange);
        recipient.pushRequestToProvider(wrappedRequestMessage);
        
        recipient.pollResponseFromProvider();
        WrappedResponseToConsumerMessage wrappedResponse = new WrappedResponseToConsumerMessage(messageExchange);
        sender.pushResponseToConsumer(wrappedResponse);
    }
}
